window.Gleam.initSearch([{"doc":"formz_string","title":"formz_string","content":"# formz_string\n\n[![Package Version](https://img.shields.io/hexpm/v/formz_string)](https://hex.pm/packages/formz_string)\n[![Hex Docs](https://img.shields.io/badge/hex-docs-ffaff3)](https://hexdocs.pm/formz_string/)\n\nString widgets and field definitions for the formz library.  See [formz](https://hexdocs.pm/formz/)\nfor details on how to use these.\n","url":"index.html"},{"doc":"formz_string","title":"main","content":"pub fn main() -&gt; Nil\n\nSynonyms:\nformz_string.main\nformz_string main","url":"formz_string.html#main"},{"doc":"formz_string","title":"formz_string","content":"","url":"formz_string.html"},{"doc":"formz_string/widgets","title":"checkbox_widget","content":"pub fn checkbox_widget() -&gt; fn(Field, Args) -&gt; String\n Create an `&lt;input type=&quot;checkbox&quot;&gt;`. The checkbox is checked\n if the value is &quot;on&quot; (the browser default).\nSynonyms:\nformz_string/widgets.checkbox_widget\nformz_string/widgets checkbox_widget","url":"formz_string/widgets.html#checkbox_widget"},{"doc":"formz_string/widgets","title":"hidden_widget","content":"pub fn hidden_widget() -&gt; fn(Field, Args) -&gt; String\n Create a `&lt;input type=&quot;hidden&quot;&gt;`. This is useful for if a field is just\n passing data around and you don&#39;t want it to be visible to the user. Like\n say, the ID of a record being edited.\nSynonyms:\nformz_string/widgets.hidden_widget\nformz_string/widgets hidden_widget","url":"formz_string/widgets.html#hidden_widget"},{"doc":"formz_string/widgets","title":"input_widget","content":"pub fn input_widget(type_: String) -&gt; fn(Field, Args) -&gt; String\n Generate any `&lt;input&gt;` like `type=&quot;text&quot;`, `type=&quot;email&quot;` or\n `type=&quot;url&quot;`.\nSynonyms:\nformz_string/widgets.input_widget\nformz_string/widgets input_widget","url":"formz_string/widgets.html#input_widget"},{"doc":"formz_string/widgets","title":"number_widget","content":"pub fn number_widget(\n  step_size: String,\n) -&gt; fn(Field, Args) -&gt; String\n Create a `&lt;input type=&quot;number&quot;&gt;`.  Normally browsers only allow whole numbers,\n unless a decimal step size is provided.  The step size here is a string that\n will be put straight into the `step-size` attribute.  Doing non-whole numbers\n this way does mean that a user can only input numbers up to the precision of\n the step size.  If you truly need any float, then a `type=&quot;text&quot;` input might be a\n better choice.\nSynonyms:\nformz_string/widgets.number_widget\nformz_string/widgets number_widget","url":"formz_string/widgets.html#number_widget"},{"doc":"formz_string/widgets","title":"password_widget","content":"pub fn password_widget() -&gt; fn(Field, Args) -&gt; String\n Create an `&lt;input type=&quot;password&quot;&gt;`. This will not output the value in the\n generated HTML for privacy/security concerns.\nSynonyms:\nformz_string/widgets.password_widget\nformz_string/widgets password_widget","url":"formz_string/widgets.html#password_widget"},{"doc":"formz_string/widgets","title":"select_widget","content":"pub fn select_widget(\n  variants: List(#(String, String)),\n) -&gt; fn(Field, Args) -&gt; String\n Create a `&lt;select&gt;&lt;/select&gt;` with `&lt;option&gt;`s for each variant.  The list\n of variants is a two-tuple, where the first item is the text to display and\n the second item is the value.\nSynonyms:\nformz_string/widgets.select_widget\nformz_string/widgets select_widget","url":"formz_string/widgets.html#select_widget"},{"doc":"formz_string/widgets","title":"textarea_widget","content":"pub fn textarea_widget() -&gt; fn(Field, Args) -&gt; String\n Create a `&lt;textarea&gt;&lt;/textarea&gt;`.\nSynonyms:\nformz_string/widgets.textarea_widget\nformz_string/widgets textarea_widget","url":"formz_string/widgets.html#textarea_widget"},{"doc":"formz_string/widgets","title":"formz_string/widgets","content":"","url":"formz_string/widgets.html"},{"doc":"formz_string/definitions","title":"boolean_field","content":"pub fn boolean_field() -&gt; Definition(\n  fn(Field, Args) -&gt; String,\n  Bool,\n  Bool,\n)\n Create a checkbox form input. Parsed as a `Bool`. If required, the parsed\n `Bool` must be `True`.\nSynonyms:\nformz_string/definitions.boolean_field\nformz_string/definitions boolean_field","url":"formz_string/definitions.html#boolean_field"},{"doc":"formz_string/definitions","title":"choices_field","content":"pub fn choices_field(\n  variants: List(#(String, a)),\n  stub stub: a,\n) -&gt; Definition(fn(Field, Args) -&gt; String, a, Option(a))\n Creates a `&lt;select&gt;` input.  Takes a tuple of `#(String, String)` where the first\n item in the tuple is the label, and the second item can be any Gleam type and\n is the value that would be parsed for a given selection.  The actual values\n rendered in the `&lt;option&gt;` tags are the numeric indeces of the items in the\n list.\n\n Because of how you build `formz` forms, you need to provide a stub of\n the value type.  Is this annoying?  Would it be more or less annoying if I\n required a non-empty list for the variants instead? I&#39;m not sure.  Let me know!\nSynonyms:\nformz_string/definitions.choices_field\nformz_string/definitions choices_field","url":"formz_string/definitions.html#choices_field"},{"doc":"formz_string/definitions","title":"email_field","content":"pub fn email_field() -&gt; Definition(\n  fn(Field, Args) -&gt; String,\n  String,\n  Option(String),\n)\n Create an email form input. Parsed as a String but must\n look like an email address, i.e. the string has an `@`.\nSynonyms:\nformz_string/definitions.email_field\nformz_string/definitions email_field","url":"formz_string/definitions.html#email_field"},{"doc":"formz_string/definitions","title":"integer_field","content":"pub fn integer_field() -&gt; Definition(\n  fn(Field, Args) -&gt; String,\n  Int,\n  Option(Int),\n)\n Create a whole number form input. Parsed as an Int.\nSynonyms:\nformz_string/definitions.integer_field\nformz_string/definitions integer_field","url":"formz_string/definitions.html#integer_field"},{"doc":"formz_string/definitions","title":"list_field","content":"pub fn list_field(\n  variants: List(String),\n) -&gt; Definition(fn(Field, Args) -&gt; String, String, Option(String))\n Creates a `&lt;select&gt;` input from a list of strings.  Validates that the parsed\n value is one of the strings in the list.\nSynonyms:\nformz_string/definitions.list_field\nformz_string/definitions list_field","url":"formz_string/definitions.html#list_field"},{"doc":"formz_string/definitions","title":"number_field","content":"pub fn number_field() -&gt; Definition(\n  fn(Field, Args) -&gt; String,\n  Float,\n  Option(Float),\n)\n Create a number form input. Parsed as a Float.\nSynonyms:\nformz_string/definitions.number_field\nformz_string/definitions number_field","url":"formz_string/definitions.html#number_field"},{"doc":"formz_string/definitions","title":"password_field","content":"pub fn password_field() -&gt; Definition(\n  fn(Field, Args) -&gt; String,\n  String,\n  Option(String),\n)\n Create a password form input, which hides the input value. Parsed as a String.\nSynonyms:\nformz_string/definitions.password_field\nformz_string/definitions password_field","url":"formz_string/definitions.html#password_field"},{"doc":"formz_string/definitions","title":"text_field","content":"pub fn text_field() -&gt; Definition(\n  fn(Field, Args) -&gt; String,\n  String,\n  String,\n)\n Create a basic form input. Parsed as a String.\nSynonyms:\nformz_string/definitions.text_field\nformz_string/definitions text_field","url":"formz_string/definitions.html#text_field"},{"doc":"formz_string/definitions","title":"formz_string/definitions","content":" Hopefully these are pretty self-explanatory. I haven&#39;t provided any\n examples here, as these are all used to build HTML forms and I don&#39;t know\n how helpful it would be to see the raw HTML.  If you&#39;d like to see\n examples of these in action, please see the [formz_demo](https://github.com/bentomas/formz/tree/main/formz_demo)\n example project.","url":"formz_string/definitions.html"},{"doc":"formz_string/simple","title":"generate_form_builder","content":"pub fn generate_form_builder(\n  form: Form(fn(Field, Args) -&gt; String, a, b, c),\n) -&gt; String\n\nSynonyms:\nformz_string/simple.generate_form_builder\nformz_string/simple generate_form_builder","url":"formz_string/simple.html#generate_form_builder"},{"doc":"formz_string/simple","title":"generate_form_use","content":"pub fn generate_form_use(\n  form: Form(fn(Field, Args) -&gt; String, a),\n) -&gt; String\n\nSynonyms:\nformz_string/simple.generate_form_use\nformz_string/simple generate_form_use","url":"formz_string/simple.html#generate_form_use"},{"doc":"formz_string/simple","title":"generate_item","content":"pub fn generate_item(\n  item: FormItem(fn(Field, Args) -&gt; String),\n) -&gt; String\n\nSynonyms:\nformz_string/simple.generate_item\nformz_string/simple generate_item","url":"formz_string/simple.html#generate_item"},{"doc":"formz_string/simple","title":"formz_string/simple","content":"","url":"formz_string/simple.html"}]);